<?php
/* Copyright start
  Copyright (C) 2008 - 2022 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\EventSubscriber;

use Doctrine\Common\EventArgs;
use Gedmo\SoftDeleteable\SoftDeleteableListener;
use Symfony\Component\HttpFoundation\RequestStack;

class CustomSoftDeleteableListener extends SoftDeleteableListener
{
    public function __construct(private RequestStack $requestStack)
    {
    }

    /**
     * If it's a SoftDeleteable object, and user has requested for hard delete
     * skip soft deleting of object and proceed with permanent delete
     *
     * @return void
     */
    public function onFlush(EventArgs $args)
    {
        $request = $this->requestStack->getCurrentRequest();
        if (!$request) {
            return;
        }
        $queryParams = $request->query->all();
        if (array_key_exists('$hardDelete', $queryParams) && $queryParams['$hardDelete']) {
            return;
        }
        parent::onFlush($args);
    }
}
